
#include <GL/gl.h>

#include "../common/defines.h"

#ifndef M_PI
#define M_PI 3.14159265
#endif

/* define COLLISION_NO_SQRT if you want faster triangle filter computation
   (with little less precision) */
/*
#define COLLISION_NO_SQRT 1
*/

/* define INGAME_DEBUG to be able to use command 'v' in the game console
   (for displaying some ingame information) */
#define INGAME_DEBUG 1

/* max amount of textures */
#define MAX_TEXTURES 512

#define EPSILON 0.1

/* the squared distance limit for lod 1 */
#define LOD_1_DISTANCE 400

/* define this if you want to use depth-of-field */
/* note that your screen resolution must be such */
/* that opengl can use it as a texture           */
/*
#define USE_DOF 1
*/

/*
#define SCREEN_X 1600
#define SCREEN_Y 1200
*/

#define SCREEN_X 512
#define SCREEN_Y 512

#define STATUS_CLEAR 0
#define STATUS_QUIT 1

#define PLAYER_MOTION_LEFT 1
#define PLAYER_MOTION_RIGHT 2
#define PLAYER_MOTION_UP 4
#define PLAYER_MOTION_DOWN 8
#define PLAYER_MOTION_RUN 16

#define PLAYER_STATUS_MOVED 1

#define MAP_NOT_LOADED 0
#define MAP_LOADED 1

/* object types */
#include "../data/obj/list.h"

/* structures */
#include "../client/structures.h"
