
/* (c) 2001-2003 ville helin <vhelin@cc.hut.fi> */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>

#include "defines.h"
#include "font.h"
#include "txt.h"
#include "../common/png.h"


extern int dirty_textures;

unsigned char *font_data;
int font_data_dx, font_data_dy;
int font_table_dx[256], font_table_start_x[256], font_table_start_y[256];


int font_init(void) {

  FILE *f;
  char c;
  int i, x, y;


  png_load("../data/font/consolefont.png", &font_data_dx, &font_data_dy, &i, &font_data);

  f = fopen("../data/font/consolefont.dat", "rb");
  if (f == NULL) {
    fprintf(stderr, "FONT_INIT: Could not open \"consolefont.dat\".\n");
    return FAILED;
  }

  for (i = 0; i < 256; i++) {
    fscanf(f, "%c", &c);
    font_table_dx[i] = (unsigned int)c;
  }

  fclose(f);

  /* compute start x and y for right aligned font data */
  for (i = 0; i < 256; i++) {
    y = i>>4;
    x = i - (y<<4);
    y = y<<5;
    x = (x<<5)+32-font_table_dx[i];
    font_table_start_x[i] = x;
    font_table_start_y[i] = y;
  }

  return SUCCEEDED;
}


int font_write_string_solid(struct txt_object *t, char *s, int sx, int sy) {

  unsigned char *i, *o;
  int fsx, fsy, fdx, fdy, x, y, c;


  c = 0;
  while (*s != 0) {
    fsx = font_table_start_x[(unsigned int)*s];
    fsy = font_table_start_y[(unsigned int)*s];
    fdx = font_table_dx[(unsigned int)*s];
    fdy = 32;
    /* copy font pixel by pixel */
    for (y = 0; y < fdy; y++) {
      i = font_data + (y+fsy)*font_data_dx*4 + fsx*4;
      o = (unsigned char *)t->txt + (y+sy)*t->x*4 + (sx+c)*4;
      for (x = 0; x < fdx; x++) {
	*(o++) = *(i++);
	*(o++) = *(i++);
	*(o++) = *(i++);
	o++;
	i++;
      }
    }
    c += fdx;
    s++;
  }

  t->dirty = YES;
  dirty_textures = YES;

  return SUCCEEDED;
}


int font_write_string_transparent(struct txt_object *t, char *s, int sx, int sy) {

  unsigned char *i, *o;
  int fsx, fsy, fdx, fdy, x, y, c;


  c = 0;
  while (*s != 0) {
    fsx = font_table_start_x[(unsigned int)*s];
    fsy = font_table_start_y[(unsigned int)*s];
    fdx = font_table_dx[(unsigned int)*s];
    fdy = 32;
    /* copy font pixel by pixel */
    for (y = 0; y < fdy; y++) {
      i = font_data + (y+fsy)*font_data_dx*4 + fsx*4;
      o = (unsigned char *)t->txt + (y+sy)*t->x*4 + (sx+c)*4;
      for (x = 0; x < fdx; x++) {
	/* black (0,0,0) is the transparent color */
	if (*(i+0) == 0 && *(i+1) == 0 && *(i+2) == 0) {
	  i += 4;
	  o += 4;
	}
	else {
	  *(o++) = *(i++);
	  *(o++) = *(i++);
	  *(o++) = *(i++);
	  o++;
	  i++;
	}
      }
    }
    c += fdx;
    s++;
  }

  t->dirty = YES;
  dirty_textures = YES;

  return SUCCEEDED;
}
