
/* (c) 2001-2003 ville helin <vhelin@cc.hut.fi> */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <time.h>

#include <GL/gl.h>

#include "defines.h"
#include "time.h"


extern GLfloat light_ambient_max[4], light_ambient[4], color_sky_max[3], color_sky[3];
extern int today_hours, today_minutes, today_seconds;
extern int connection_status;
double today_light, today_fog;
int tos = 0;


int time_adjust_light(int h, int m, int s) {

  struct tm *ti;
  time_t t;


  /* compute the time */
  if (connection_status == OFF) {
    time(&t);
    ti = localtime(&t);
    h = ti->tm_hour;
    m = ti->tm_min;
    s = ti->tm_sec;
    today_hours = h;
    today_minutes = m;
    today_seconds = s;

    /*
    h = tos/(60*60);
    m = (tos-h*60*60)/60;
    s = tos-(h*60*60)-m*60;

    today_hours = h;
    today_minutes = m;
    today_seconds = s;

    tos += 60;
    if (tos == 24*60*60)
      tos = 0;
    */
  }
  else {
    h = today_hours;
    m = today_minutes;
    s = today_seconds;
  }

  h = 14;
  m = 0;
  s = 0;

  /* sunrise! */
  if (h >= 6 && h <= 10) {
    h -= 6;
    s += m*60 + h*60*60;
    today_light = ((double)s)/(5*60*60);
  }
  /* sun up! */
  else if (h > 10 && h < 16) {
    today_light = 1;
  }
  /* sunset! */
  else if (h >= 16 && h <= 21) {
    h -= 16;
    s += m*60 + h*60*60;
    today_light = (6*60*60-((double)s))/(6*60*60);
  }
  /* sun down */
  else {
    today_light = 0;
  }

  today_light *= 0.87;

  /* compute fog */
  today_fog = 0.044 - today_light/20;

  light_ambient[0] = light_ambient_max[0] * today_light*4;
  light_ambient[1] = light_ambient_max[1] * today_light*4;
  light_ambient[2] = light_ambient_max[2] * today_light*4;
  /*
  color_sky[0] = color_sky_max[0] * today_light;
  color_sky[1] = color_sky_max[1] * today_light;
  color_sky[2] = color_sky_max[2] * today_light;
  */

  color_sky[0] = 0;
  color_sky[1] = 0;
  color_sky[2] = 0;

  return SUCCEEDED;
}
