
/* (c) 2001-2003 ville helin <vhelin@cc.hut.fi> */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <signal.h>

#include "defines.h"
#include "parse.h"


int generate_port(int *po) {

  static int c = 0;


  *po = rand() + c;
  *po = (*po % (0xFFFF - IPPORT_USERRESERVED)) + IPPORT_USERRESERVED;
  c++;

  return SUCCEEDED;
}


int read_double_a(char *c, int *e, double *d) {

  double q;
  char *x;
  int i;


  x = (char *)&q;
  c += *e;
  for (i = 0; i < sizeof(double); i++)
    *(x++) = *(c++);
  *d = q;

  *e += sizeof(double);

  return SUCCEEDED;
}


int read_double(char *c, double *d) {

  double q;
  char *x;
  int i;


  x = (char *)&q;
  for (i = 0; i < sizeof(double); i++)
    *(x++) = *(c++);
  *d = q;

  return SUCCEEDED;
}


int read_float(char *c, float *d) {

  float q;
  char *x;
  int i;


  x = (char *)&q;
  for (i = 0; i < sizeof(float); i++)
    *(x++) = *(c++);
  *d = q;

  return SUCCEEDED;
}


int read_float_a(char *c, int *e, float *d) {

  float q;
  char *x;
  int i;


  x = (char *)&q;
  c += *e;
  for (i = 0; i < sizeof(float); i++)
    *(x++) = *(c++);
  *d = q;

  *e += sizeof(float);

  return SUCCEEDED;
}


int write_double(char *c, double d) {

  double k;
  char *x;
  int i;


  k = d;
  x = (char *)&k;
  for (i = 0; i < sizeof(double); i++)
    *(c++) = *(x++);

  return SUCCEEDED;
}


int write_double_a(char *c, int *e, double d) {

  double k;
  char *x;
  int i;


  k = d;
  c += *e;
  x = (char *)&k;
  for (i = 0; i < sizeof(double); i++)
    *(c++) = *(x++);

  *e += sizeof(double);

  return SUCCEEDED;
}


int write_int(char *c, int d) {

  char *x;
  int i, k;


  k = d;
  x = (char *)&k;
  for (i = 0; i < sizeof(int); i++)
    *(c++) = *(x++);

  return SUCCEEDED;
}


int file_write_int(FILE *f, int d) {

  char *x;
  int i, k;


  k = d;
  x = (char *)&k;
  for (i = 0; i < sizeof(int); i++, x++)
    fprintf(f, "%c", *x);

  return SUCCEEDED;
}


int write_int_a(char *c, int *e, int d) {

  char *x;
  int i, k;


  k = d;
  c += *e;
  x = (char *)&k;
  for (i = 0; i < sizeof(int); i++)
    *(c++) = *(x++);

  *e += sizeof(int);

  return SUCCEEDED;
}


int write_float(char *c, float d) {

  float k;
  char *x;
  int i;


  k = d;
  x = (char *)&k;
  for (i = 0; i < sizeof(float); i++)
    *(c++) = *(x++);

  return SUCCEEDED;
}


int file_write_float(FILE *f, float d) {

  float k;
  char *x;
  int i;


  k = d;
  x = (char *)&k;
  for (i = 0; i < sizeof(float); i++, x++)
    fprintf(f, "%c", *x);

  return SUCCEEDED;
}


int write_float_a(char *c, int *e, float d) {

  float k;
  char *x;
  int i;


  k = d;
  c += *e;
  x = (char *)&k;
  for (i = 0; i < sizeof(float); i++)
    *(c++) = *(x++);

  *e += sizeof(float);

  return SUCCEEDED;
}


int read_int(char *c, int *d) {

  char *x;
  int i;


  x = (char *)d;
  for (i = 0; i < sizeof(int); i++)
    *(x++) = *(c++);

  return SUCCEEDED;
}


int file_read_int(FILE *f, int *d) {

  char *x;
  int i;


  x = (char *)d;
  for (i = 0; i < sizeof(int); i++, x++)
    fscanf(f, "%c", x);

  return SUCCEEDED;
}


int file_read_float(FILE *f, float *d) {

  char *x;
  int i;


  x = (char *)d;
  for (i = 0; i < sizeof(float); i++, x++)
    fscanf(f, "%c", x);

  return SUCCEEDED;
}


int read_int_a(char *c, int *e, int *d) {

  char *x;
  int i;


  c += *e;
  x = (char *)d;
  for (i = 0; i < sizeof(int); i++)
    *(x++) = *(c++);

  *e += sizeof(int);

  return SUCCEEDED;
}


int write_out_double(FILE *f, double d, char c) {

  char tmp[64];
  int s;


  sprintf(tmp, "%f", d);
  s = strlen(tmp);

  if (s >= 64) {
    fprintf(stderr, "WRITE_OUT_DOUBLE: Too long a double (%d characters)... Imminent death.\n", s);
    exit(0);
  }

  s--;

  while (1) {
    if (tmp[s] == '0')
      tmp[s] = 0;
    else if (tmp[s] == '.') {
      s--;
      break;
    }
    else
      break;
    s--;
    if (s == 0)
      break;
  }
  s++;

  tmp[s++] = c;
  tmp[s] = 0;
  fprintf(f, tmp);

  return SUCCEEDED;
}
