
/* (c) 2003 ville helin <vhelin@cc.hut.fi> */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>

#include "defines.h"
#include "png.h"



int screen_capture(void) {

  static int i = 1;
  unsigned char a, b, c;
  unsigned char *t;
  GLint vp[4];
  char n[64];
  int x;


  glGetIntegerv(GL_VIEWPORT, vp);

  t = malloc(vp[2]*vp[3]*4);
  if (t == NULL) {
    fprintf(stderr, "SCREEN_CAPTURE: Out of memory error.\n");
    return FAILED;
  }

  glReadPixels(0, 0, vp[2], vp[3], GL_RGBA, GL_UNSIGNED_BYTE, t);

  /* take the alpha away */
  for (x = 0; x < vp[2]*vp[3]; x++) {
    a = *(t+x*4+0);
    b = *(t+x*4+1);
    c = *(t+x*4+2);
    *(t+x*3+0) = a;
    *(t+x*3+1) = b;
    *(t+x*3+2) = c;
  }

  sprintf(n, "capture_%.3d.png", i);
  png_save(n, vp[2], vp[3], GL_RGB, t);
  i++;

  free(t);

  return SUCCEEDED;
}
