
#include "../common/common.h"
#include "../data/obj/list.h"

#define DISTANCE_AUDIBILITY 100000
#define DISTANCE_VISIBILITY 100000

#define STATUS_STARTUP 0
#define STATUS_READY   1
#define STATUS_QUIT    2

#define SPECIAL_NONE    0
#define SPECIAL_ALL     1
#define SPECIAL_MESSAGE 2

#define MAX_STARTING_POINTS 3

struct game_object {
  unsigned int id;
  int type;
  int object;
  int status;
  char name[64];
  int cx, cy, cz;
  double x, y, z;
  float ax, ay, az;
  unsigned int change_time;
  struct game_object *next, *prev;
};

struct inventory_item {
  int object;
  struct inventory_item *next, *prev;
};

struct player {
  int port;
  int machine;
  int socket;
  int status;
  int lantern_status;
  int visibility;
  int comm_buffer_size;
  int comm_buffer_i;
  int dummy_objects_i;
  int dummy_objects[DUMMY_OBJECTS];
  char *comm_buffer;
  unsigned int previous_time;
  unsigned int output_bytes;
  unsigned int *world_time;
  unsigned char m1, m2, m3, m4;
  struct game_object *go;
  struct inventory_item *inventory;
  struct player *next, *prev;
};

struct psystem {
  int type;
  int id;
  double x, y, z;
  float rx, ry, rz;
  int cx, cy, cz;
  unsigned int change_time;
  struct psystem *next, *prev;
};
