
/* (c) 2001-2003 ville helin <vhelin@cc.hut.fi> */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "defines.h"
#include "id.h"


char *id_pool = NULL;
int id_base = 0;


int initialize_id_pool(void) {

  id_base = 0;
  id_pool = malloc(MAX_ID + 1);
  if (id_pool == NULL) {
    fprintf(stderr, "INITIALIZE_ID_POOL: Out of memory error.\n");
    return FAILED;
  }
  memset(id_pool, 0, MAX_ID + 1);

  return SUCCEEDED;
}


int generate_id(unsigned int *i) {

  unsigned int x;


  x = 0;
  while (id_pool[id_base] != 0) {
    id_base = (id_base + 1) & MAX_ID;
    x++;
    if (x == MAX_ID + 1) {
      fprintf(stderr, "GENERATE_ID: Out of ID numbers.\n");
      return FAILED;
    }
  }

  id_pool[id_base] = 1;
  *i = id_base++;

  return SUCCEEDED;
}


int free_id(unsigned int i) {

  if (i > MAX_ID) {
    fprintf(stderr, "FREE_ID: ID %d is out of range.\n", i);
    return FAILED;
  }

  if (id_pool[i] == 0)
    fprintf(stderr, "FREE_ID: Freeing an unused id %d.\n", i);

  id_pool[i] = 0;

  return SUCCEEDED;
}
